//
// Copyright (c) 2012 Samsung Electronics Co., Ltd.
//
// Licensed under the Flora License, Version 1.1 (the License);
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://floralicense.org/license/
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an AS IS BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#ifndef _GALLERY_APPWIDGET_FRAME_H_
#define _GALLERY_APPWIDGET_FRAME_H_

#include <FBaseObject.h>
#include <FUi.h>
#include <FShell.h>

namespace Tizen { namespace Ui { namespace Controls { class Form; } } }
class GalleryAppWidgetState;

class GalleryAppWidgetFrame
	: public Tizen::Shell::AppWidgetFrame
	, public Tizen::Ui::ITouchEventListener
{
public:
	GalleryAppWidgetFrame();
	virtual ~GalleryAppWidgetFrame();
	virtual result OnInitializing(void);
	virtual result OnTerminating(void);
	virtual void OnBoundsChanged(const Tizen::Graphics::Rectangle& oldRect, const Tizen::Graphics::Rectangle& newRect);
	void OnAppWidgetUpdate();

	virtual void OnTouchPressed(const Tizen::Ui::Control& source, const Tizen::Graphics::Point& currentPosition, const Tizen::Ui::TouchEventInfo & touchInfo) {}
	virtual void OnTouchReleased(const Tizen::Ui::Control& source, const Tizen::Graphics::Point& currentPosition, const Tizen::Ui::TouchEventInfo& touchInfo);
	virtual void OnTouchMoved(const Tizen::Ui::Control& source, const Tizen::Graphics::Point& currentPosition, const Tizen::Ui::TouchEventInfo& touchInfo) {}
	virtual void OnTouchFocusIn(const Tizen::Ui::Control& source, const Tizen::Graphics::Point& currentPosition, const Tizen::Ui::TouchEventInfo& touchInfo) {}
	virtual void OnTouchFocusOut(const Tizen::Ui::Control& source, const Tizen::Graphics::Point& currentPosition, const Tizen::Ui::TouchEventInfo& touchInfo) {}


private:
	Tizen::Ui::Controls::Label* __pLabel;
	Tizen::Graphics::Bitmap* __pImage;
	GalleryAppWidgetState* __pData;
};

#endif /* _GALLERY_APPWIDGET_FRAME_H_ */
