//
// Copyright (c) 2012 Samsung Electronics Co., Ltd.
//
// Licensed under the Flora License, Version 1.1 (the License);
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://floralicense.org/license/
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an AS IS BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#ifndef _GALLERY_DYNAMIC_BOX_H_
#define _GALLERY_DYNAMIC_BOX_H_

#include <FApp.h>
#include <FBase.h>
#include <FSystem.h>
#include "GalleryAppWidgetProviderFactory.h"
#include "GalleryAppWidgetPopupProviderFactory.h"

/**
 * [GalleryDynamicBox] ServiceApp must inherit from ServiceApp class
 * which provides basic features necessary to define an ServiceApp.
 */
class GalleryDynamicBox
	: public Tizen::App::ServiceApp
{
public:

	/**
	 * [GalleryDynamicBox] ServiceApp must have a factory method that creates an instance of itself.
	 */
	static Tizen::App::ServiceApp* CreateInstance(void);

public:

	GalleryDynamicBox(void);
	~GalleryDynamicBox(void);

public:

	// Called when the ServiceApp is initializing.
	bool OnAppInitializing(Tizen::App::AppRegistry& appRegistry);

	// Called when the ServiceApp initializing is finished.
	bool OnAppInitialized(void); 

	// Called when the ServiceApp is requested to terminate.
	bool OnAppWillTerminate(void);

	// Called when the ServiceApp is terminating.
	bool OnAppTerminating(Tizen::App::AppRegistry& appRegistry, bool forcedTermination = false);

	// Called when the system memory is not sufficient to run the ServiceApp any further.
	void OnLowMemory(void);

	// Called when the battery level changes.
	void OnBatteryLevelChanged(Tizen::System::BatteryLevel batteryLevel);

private:
	GalleryAppWidgetProviderFactory __appwidgetProviderFactory;
	GalleryAppWidgetPopupProviderFactory __appwidgetPopupProviderFactory;
};

#endif // _GALLERY_DYNAMIC_BOX_H_
